PROGRAM TMenu;

USES
  Crt, Divers, Dos;

CONST
  Nom : ARRAY[1..50] OF INTEGER=
        (420,585,570,490,555,160,385,505,550,585,160,590,245,230,245,160,160,
         200,495,205,160,245,285,285,260,225,285,265,160,160,560,485,570,160,
         415,650,490,485,575,580,525,505,550,160,360,345,380,380,345,425);

VAR
  i,j,NbOpt,x,y,Maxi,PosBarre : BYTE;
  Temps                       : SHORTINT;
  Code                        : INTEGER;
  Opt                         : ARRAY[1..23] OF STRING[80];
  h, m, s, s2, cs             : WORD;
  Time, Centre                : BOOLEAN;
  Ecran                       : ARRAY[1..4096] OF BYTE;
  Reaffiche_ecran             : BOOLEAN;
  LowAdd                      : WORD;
  xc,yc                       : BYTE;
  Simple                      : BOOLEAN;
  Titre                       : STRING;
  Couleur,Fond                : SHORTINT;
  Path                        : PATHSTR;   { Variables }
  Direc                       : DIRSTR;    {          utilises }
  Nomfich                     : NAMESTR;   {                   pour }
  Ext                         : EXTSTR;    {                       FSplit }

  PROCEDURE Lit_Parametres;
    VAR
      Trouve,Option,Title : BOOLEAN;
    BEGIN
      Option:=False; Title:=False;
      FOR i:=1 TO ParamCount DO
        BEGIN
          Trouve:=False;
          IF (Maj(Copy(ParamStr(i),1,3))='/D:') AND (Length(ParamStr(i))>3) THEN
            BEGIN
              Trouve:=True;
              Time:=True;
              Val(Copy(ParamStr(i),4,Length(ParamStr(i))-3),Temps,Code);
              IF (Code<>0) OR (Temps<=0) OR (Temps>255) THEN
                BEGIN
			      WriteLn;
			      WriteLn('Mauvaise spcification de temps : 1  t  255  (t doit tre un entier)');
                  Curseur(6,7);
                  Halt
                END
            END;
          IF (Maj(Copy(ParamStr(i),1,3))='/X:') AND (Length(ParamStr(i))>3) THEN
            BEGIN
              Trouve:=True;
              Val(Copy(ParamStr(i),4,Length(ParamStr(i))-3),x,Code);
              IF (Code<>0) OR (x<1) OR (x>Lo(WindMax)+1) THEN
                BEGIN
                  WriteLn;
                  WriteLn('Mauvaise spcification d''abscisse du menu : 1  x  ',Lo(WindMax)+1);
                  Curseur(6,7);
                  Halt
                END
            END;
          IF (Maj(Copy(ParamStr(i),1,3))='/Y:') AND (Length(ParamStr(i))>3) THEN
            BEGIN
              Trouve:=True;
              Val(Copy(ParamStr(i),4,Length(ParamStr(i))-3),y,Code);
              IF (Code<>0) OR (y<1) OR (y>Hi(WindMax)+1) THEN
                BEGIN
                  WriteLn;
                  WriteLn('Mauvaise spcification d''ordonne du menu : 1  y  ',Hi(WindMax)-1,'-NbOpt');
                  Curseur(6,7);
                  Halt
                END
            END;
          IF (Maj(Copy(ParamStr(i),1,3))='/T:') AND (Length(ParamStr(i))>3) THEN
            BEGIN
              Trouve:=True; Option:=False; Title:=True;
              Titre:=Copy(ParamStr(i),4,Length(ParamStr(i))-3)
            END;
          IF (Maj(Copy(ParamStr(i),1,4))='/CO:') AND (Length(ParamStr(i))>4) THEN
            BEGIN
              Trouve:=True;
              Val(Copy(ParamStr(i),5,Length(ParamStr(i))-4),Couleur,Code);
              IF (Code<>0) OR (Couleur<0) OR (Couleur>15) THEN
                BEGIN
                  WriteLn;
                  WriteLn('Mauvaise spcification de couleur : 0  co  15');
                  Curseur(6,7);
                  Halt
                END;
              Fond:=0
            END;
          IF Maj(ParamStr(i))='/DC' THEN
            BEGIN Trouve:=True; Simple:=False END;
          IF Maj(ParamStr(i))='/C' THEN
            BEGIN Trouve:=True; Centre:=True END;
          IF Copy(ParamStr(i),1,1)='*' THEN
            BEGIN
              Option:=True; Title:=False; Inc(Nbopt);
              Opt[Nbopt]:=Copy(ParamStr(i),2,Length(ParamStr(i))-1)
            END
          ELSE
            IF Not Trouve THEN
              BEGIN
                IF Option THEN
                  Opt[Nbopt]:=Opt[Nbopt]+' '+ParamStr(i)
                ELSE
                  IF Title THEN Titre:=Titre+' '+ParamStr(i)
              END
	    END
    END;

  PROCEDURE Fini(a : BOOLEAN); {a=False si ESC press ou si le temps est fini}
    BEGIN
      Curseur(6,7);
      NormVideo;
      IF Reaffiche_ecran THEN
        BEGIN
          Move(Ecran,Mem[LowAdd:0],4096);
          GotoXY(xc,yc-1)
        END
      ELSE
        BEGIN
          IF Titre='' THEN
            BEGIN Efface(x,y,80,y+NbOpt+1,Black); GotoXY(1,y-1) END
          ELSE
            BEGIN Efface(x,y-2,80,y+NbOpt+1,Black); GotoXY(1,y-3) END
        END;
      IF a THEN Halt(PosBarre);
      Halt
    END;

  PROCEDURE Choisit;
    VAR
	  k : CHAR;

    PROCEDURE Dec_Temps;
      BEGIN
        IF s<>s2 THEN BEGIN Dec(Temps); s2:=s END;
        IF Temps<0 THEN Fini(True);
        GetTime(h,m,s,cs);
        IF Titre='' THEN
          GotoXY(x+Maxi+5,y+1)
        ELSE
          GotoXY(x+Maxi+5,y-1);
        Write(Temps,' ')
      END;

    PROCEDURE Affiche;
      BEGIN
        TextColor(Fond); TextBackGround(Couleur);
        GotoXY(x+2,y+PosBarre);
        Write(' ',Opt[PosBarre]);
        IF Length(Opt[PosBarre])<Maxi THEN
          FOR i:=1 TO Maxi-Length(Opt[PosBarre]) DO Write(' ');
        TextColor(Couleur); TextBackGround(Fond)
      END;

    PROCEDURE Enleve;
      BEGIN
        GotoXY(x+2,y+PosBarre);
        Write(' ',Opt[PosBarre]);
        IF Length(Opt[PosBarre])<Maxi THEN
          FOR i:=1 TO Maxi-Length(Opt[PosBarre]) DO Write(' ')
      END;

    BEGIN  { de Choisit }
      TextColor(Couleur); TextBackGround(Fond);
      IF Titre<>'' THEN y:=y+2;
      IF ((Titre='') AND (y+Nbopt+1>24)) OR ((Titre<>'') AND (y+NbOpt+3>24)) THEN
	    BEGIN
		  GotoXY(1,25);
          IF Titre='' THEN
            BEGIN FOR i:=1 TO y+Nbopt-24 DO WriteLn; y:=24-NbOpt END
          ELSE
            BEGIN FOR i:=1 TO y+NbOpt-22 DO WriteLn; y:=22-NbOpt END;
          Reaffiche_ecran:=False
		END;
      GotoXY(1,y); Maxi:=0;
      FOR i:=1 TO Nbopt DO IF Length(Opt[i])+1>Maxi THEN Maxi:=Length(Opt[i])+1;
      IF Length(Titre)>Maxi THEN Maxi:=Length(Titre)+1;
      IF Centre THEN
        FOR i:=1 TO Nbopt DO
          BEGIN
            FOR j:=1 TO (Maxi-Length(Opt[i])-1) div 2 DO
              Opt[i]:=' '+Opt[i];
            WHILE Length(Opt[i])<Maxi DO
              Opt[i]:=Opt[i]+' '
          END;
      IF Titre<>'' THEN
        BEGIN
          FOR j:=1 TO (Maxi-Length(Titre)) div 2 DO
            Titre:=' '+Titre;
          WHILE Length(Titre)<Maxi DO
            Titre:=Titre+' '
        END;
      IF Titre='' THEN
        BEGIN
	      Efface(x,y,x+Maxi+4,y+Nbopt+1,Black);
          IF Simple THEN
            SimpleCadre(x,y,x+Maxi+4,y+Nbopt+1)
          ELSE
            DoubleCadre(x,y,x+Maxi+4,y+NbOpt+1)
        END
      ELSE
        BEGIN
          Efface(x,y-2,x+Maxi+4,y+NbOpt+1,Black);
          IF Simple THEN
            SimpleCadre(x,y-2,x+Maxi+4,y+NbOpt+1)
          ELSE
            DoubleCadre(x,y-2,x+Maxi+4,y+NbOpt+1);
          GotoXY(x,y);
          IF Simple THEN Write('') ELSE Write('');
          FOR j:=1 TO Maxi+3 DO Write('');
          IF Simple THEN Write('') ELSE Write('');
          GotoXY(x+3,y-1); Write(Titre)
        END;
      FOR i:=1 TO Nbopt DO
	    BEGIN GotoXY(x+2,y+i); Write(' ',Opt[i]) END;
      PosBarre:=1; Affiche; GetTime(h,m,s,cs); s2:=s;
      REPEAT
        REPEAT IF Time THEN Dec_Temps UNTIL KeyPressed;
		k:=ReadKey;
        IF k=#27 THEN Fini(False);
        IF k=#0 THEN
		  BEGIN
		    k:=ReadKey;
            IF (k='H') AND (PosBarre>1) THEN
              BEGIN Enleve; Dec(PosBarre); Affiche END;
            IF (k='P') AND (PosBarre<Nbopt) THEN
              BEGIN Enleve; Inc(PosBarre); Affiche END;
            IF ((k='G') OR (k='I')) AND (PosBarre>1) THEN
              BEGIN Enleve; PosBarre:=1; Affiche END;
            IF ((k='O') OR (k='Q')) AND (PosBarre<Nbopt) THEN
              BEGIN Enleve; PosBarre:=Nbopt; Affiche END
          END;
      UNTIL k=#13;
      Fini(True)
    END;

BEGIN
  CheckBreak:=False;
  Path:=ParamStr(0);
  FSplit(Path,Direc,Nomfich,Ext);
  IF (ParamCount=0) OR (ParamStr(1)='/?') THEN
    BEGIN
      WriteLn; FOR i:=1 TO 50 DO Write(Chr(Nom[i] div 5)); WriteLn; WriteLn;
      WriteLn('Affiche un menu et attend qu''un choix soit fait [dans un dlai limit] avant de');
      WriteLn('renvoyer un code erreur (errorlevel) au Dos.');
      WriteLn; WriteLn(Nomfich,' *Option1 *Option2 [ ... ] [/C] [/CO:no] [/D:sec] [/DC] [/T:titre]');
      GotoXY(Length(Nomfich)+2,WhereY); WriteLn('[/X|Y:coord]');
      WriteLn; WriteLn('    *Optionx   Texte  afficher dans le menu.');
      WriteLn('    /C         Centre toutes les options du menu.');
      WriteLn('    /CO:no     Numro de la couleur du menu (de 0  15, voir ci-dessous).');
      WriteLn('    /D:sec     Dlai (en secondes) d''apparition du menu.');
      WriteLn('    /DC        Affiche le menu entour d''un double cadre.');
      WriteLn('    /T:titre   Affiche le menu avec le "titre" spcifi.');
      WriteLn('    /X:coord   Abscisse du menu sur l''cran.');
      WriteLn('    /Y:coord   Ordonne du menu sur l''cran.');
	  WriteLn; WriteLn('Pour analyser la rponse (dans un fichier Batch),il faut tudier Errorlevel.');
      WriteLn; WriteLn('Couleurs : Noir=0;Bleu=1;Vert=2;Cyan=3;Rouge=4;Magenta=5;Marron=6;Gris.cl=7;');
      WriteLn('           Gris.fo=8;Bleu.cl=9;Vert.cl=10;Cyan.cl=11;Rouge.cl=12;Magenta.cl=13;');
      WriteLn('           Jaune=14;Blanc=15');
	  Halt
    END;
  Curseur(32,8);
  Nbopt:=0; x:=1; y:=WhereY;
  Temps:=0; Time:=False; Centre:=False;
  Simple:=True; Titre:='';
  Couleur:=TextAttr; Fond:=Couleur AND 56;
  Lit_Parametres;
  IF Nbopt>21 THEN
    BEGIN
	  WriteLn; WriteLn('Trop d''options dans le menu : 2  nb opt  21');
      Curseur(6,7); Halt
	END;
  IF Nbopt<2 THEN
    BEGIN
	  WriteLn; WriteLn('Le menu doit comporter au moins 2 options : 2  nb opt  23');
      Curseur(6,7); Halt
	END;
  IF (Mem[$0040:$0010] AND $30)=$30 THEN LowAdd:=$B000 ELSE LowAdd:=$B800;
  xc:=WhereX; yc:=WhereY;
  Move(Mem[LowAdd:0],Ecran,4096);
  Reaffiche_ecran:=True;
  Choisit
END.